JUCE: PixelARGB Class Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
PixelARGB Class Reference
juce_graphics » colour

Represents a 32-bit INTERNAL pixel with premultiplied alpha, and can perform compositing operations with it. More...

`#include <juce_PixelFormats.h>`

## Public Types
enum | { indexA = 3 , indexR = 0 , indexG = 1 , indexB = 2 }
| The indexes of the different components in the byte layout of this type of colour. More...

## Public Member Functions
| PixelARGB () noexcept=default
| Creates a pixel without defining its colour.
| PixelARGB (uint8 a, uint8 r, uint8 g, uint8 b) noexcept
forcedinline uint32 | getNativeARGB () const noexcept
| Returns a uint32 which represents the pixel in a platform dependent format.
forcedinline uint32 | getInARGBMaskOrder () const noexcept
| Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue).
uint32 | getInARGBMemoryOrder () const noexcept
| Returns a uint32 which when written to memory, will be in the order a, r, g, b.
forcedinline uint32 | getEvenBytes () const noexcept
| Return channels with an even index and insert zero bytes between them.
forcedinline uint32 | getOddBytes () const noexcept
| Return channels with an odd index and insert zero bytes between them.
forcedinline uint8 | getAlpha () const noexcept
forcedinline uint8 | getRed () const noexcept
forcedinline uint8 | getGreen () const noexcept
forcedinline uint8 | getBlue () const noexcept
template<class Pixel >
forcedinline void | set (const Pixel &src) noexcept
| Copies another pixel colour over this one.
void | setARGB (uint8 a, uint8 r, uint8 g, uint8 b) noexcept
| Sets the pixel's colour from individual components.
template<class Pixel >
forcedinline void | blend (const Pixel &src) noexcept
| Blends another pixel onto this one.
forcedinline void | blend (PixelRGB src) noexcept
| Blends another pixel onto this one.
template<class Pixel >
forcedinline void | blend (const Pixel &src, uint32 extraAlpha) noexcept
| Blends another pixel onto this one, applying an extra multiplier to its opacity.
template<class Pixel >
forcedinline void | tween (const Pixel &src, uint32 amount) noexcept
| Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount.
forcedinline void | setAlpha (uint8 newAlpha) noexcept
| Replaces the colour's alpha value with another one.
forcedinline void | multiplyAlpha (int multiplier) noexcept
| Multiplies the colour's alpha value with another one.
forcedinline void | multiplyAlpha (float multiplier) noexcept
PixelARGB | getUnpremultiplied () const noexcept
forcedinline void | premultiply () noexcept
| Premultiplies the pixel's RGB values by its alpha.
forcedinline void | unpremultiply () noexcept
| Unpremultiplies the pixel's RGB values.
forcedinline void | desaturate () noexcept

## Detailed Description

Represents a 32-bit INTERNAL pixel with premultiplied alpha, and can perform compositing operations with it.

This is used internally by the imaging classes.

See also
  PixelRGB

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

The indexes of the different components in the byte layout of this type of colour.

Enumerator
indexA |
indexR |
indexG |
indexB |

## Constructor & Destructor Documentation

## ◆ PixelARGB() [1/2]

PixelARGB::PixelARGB | ( |  | ) |
| defaultnoexcept

Creates a pixel without defining its colour.

## ◆ PixelARGB() [2/2]

PixelARGB::PixelARGB | ( | uint8 | a,
|  | uint8 | r,
|  | uint8 | g,
|  | uint8 | b
| ) |  |
| noexcept

## Member Function Documentation

## ◆ getNativeARGB()

forcedinline uint32 PixelARGB::getNativeARGB | ( |  | ) | const
| noexcept

Returns a uint32 which represents the pixel in a platform dependent format.

## ◆ getInARGBMaskOrder()

forcedinline uint32 PixelARGB::getInARGBMaskOrder | ( |  | ) | const
| noexcept

Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue).

## ◆ getInARGBMemoryOrder()

uint32 PixelARGB::getInARGBMemoryOrder | ( |  | ) | const
| noexcept

Returns a uint32 which when written to memory, will be in the order a, r, g, b.

In other words, if the return-value is read as a uint8 array then the elements will be in the order of a, r, g, b

## ◆ getEvenBytes()

forcedinline uint32 PixelARGB::getEvenBytes | ( |  | ) | const
| noexcept

Return channels with an even index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent.

## ◆ getOddBytes()

forcedinline uint32 PixelARGB::getOddBytes | ( |  | ) | const
| noexcept

Return channels with an odd index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent.

## ◆ getAlpha()

forcedinline uint8 PixelARGB::getAlpha | ( |  | ) | const
| noexcept

Referenced by Colour::getAlpha().

## ◆ getRed()

forcedinline uint8 PixelARGB::getRed | ( |  | ) | const
| noexcept

## ◆ getGreen()

forcedinline uint8 PixelARGB::getGreen | ( |  | ) | const
| noexcept

## ◆ getBlue()

forcedinline uint8 PixelARGB::getBlue | ( |  | ) | const
| noexcept

## ◆ set()

template<class Pixel >

forcedinline void PixelARGB::set | ( | const Pixel & | src | ) |
| noexcept

Copies another pixel colour over this one.

This doesn't blend it - this colour is simply replaced by the other one.

## ◆ setARGB()

void PixelARGB::setARGB | ( | uint8 | a,
|  | uint8 | r,
|  | uint8 | g,
|  | uint8 | b
| ) |  |
| noexcept

Sets the pixel's colour from individual components.

## ◆ blend() [1/2]

template<class Pixel >

forcedinline void PixelARGB::blend | ( | const Pixel & | src | ) |
| noexcept

Blends another pixel onto this one.

This takes into account the opacity of the pixel being overlaid, and blends it accordingly.

References clampPixelComponents(), and maskPixelComponents().

## ◆ blend() [2/2]

template<class Pixel >

forcedinline void PixelARGB::blend | ( | const Pixel & | src,
|  | uint32 | extraAlpha
| ) |  |
| noexcept

Blends another pixel onto this one, applying an extra multiplier to its opacity.

The opacity of the pixel being overlaid is scaled by the extraAlpha factor before being used, so this can blend semi-transparently from a PixelRGB argument.

References clampPixelComponents(), and maskPixelComponents().

## ◆ tween()

template<class Pixel >

forcedinline void PixelARGB::tween | ( | const Pixel & | src,
|  | uint32 | amount
| ) |  |
| noexcept

Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount.

## ◆ setAlpha()

forcedinline void PixelARGB::setAlpha | ( | uint8 | newAlpha | ) |
| noexcept

Replaces the colour's alpha value with another one.

## ◆ multiplyAlpha() [1/2]

forcedinline void PixelARGB::multiplyAlpha | ( | int | multiplier | ) |
| noexcept

Multiplies the colour's alpha value with another one.

## ◆ multiplyAlpha() [2/2]

forcedinline void PixelARGB::multiplyAlpha | ( | float | multiplier | ) |
| noexcept

## ◆ getUnpremultiplied()

PixelARGB PixelARGB::getUnpremultiplied | ( |  | ) | const
| noexcept

References unpremultiply().

## ◆ premultiply()

forcedinline void PixelARGB::premultiply | ( |  | ) |
| noexcept

Premultiplies the pixel's RGB values by its alpha.

## ◆ unpremultiply()

forcedinline void PixelARGB::unpremultiply | ( |  | ) |
| noexcept

Unpremultiplies the pixel's RGB values.

References jmin().

Referenced by getUnpremultiplied().

## ◆ desaturate()

forcedinline void PixelARGB::desaturate | ( |  | ) |
| noexcept

## Member Data Documentation

## ◆ internal

uint32 PixelARGB::internal

## ◆ components

Components PixelARGB::components

The documentation for this class was generated from the following file:

- juce_PixelFormats.h